<template>
	<div>
		<v-text-field
			v-model="search"
			append-icon="mdi-magnify"
			label="Введите текст для поиска"
			single-line
			hide-details
			class="my-8"
		></v-text-field>
		<v-data-table
			:headers="headers"
			:items="landlords"
			:options.sync="options"
			:server-items-length="totalLandlords"
			:loading="loading"
			class="elevation-1"
			item-key="id"
			:single-expand="true"
			:expanded.sync="expanded"
			show-expand
		>
			<!-- hide-default-footer -->
			<template v-slot:header>
				<thead>
					<tr>
						<th colspan="3" class="text-center">Данные о собственнике</th>
						<th colspan="8" class="text-center">Начисления (руб.)</th>
					</tr>
				</thead>
			</template>
			<template v-slot:item.paid="{ item }">
				<v-simple-checkbox v-model="item.paid"></v-simple-checkbox>
			</template>
			<template v-slot:item.link="{ item }">
				<v-btn :to="`landlords/${item.id}`" icon>
					<v-icon>mdi-chevron-right</v-icon>
				</v-btn>
			</template>
			<template v-slot:expanded-item="{ headers, item }">
				<td :colspan="headers.length">Телефон: {{ item.phone }}</td>
			</template>
			<template v-slot:footer>
				<div class="block-table-landlords__footer-btns px-2 py-3">
					<v-btn class="ma-1" small>
						<v-icon left>mdi-download-outline</v-icon>
						Скачать данные
					</v-btn>
					<v-btn class="ma-1" small>
						<v-icon left>mdi-upload-outline</v-icon>
						Загрузить данные
					</v-btn>
				</div>
			</template>
		</v-data-table>
	</div>
</template>

<script>
	export default {
		name: 'BlockTableLandlords',
		data () {
			return {
				expanded: [],
				search: '',
				totalLandlords: 0,
				landlords: [],
				loading: true,
				options: {},
				headers: [
					{
						text: 'ФИО',
						align: 'start',
						sortable: true,
						value: 'fio',
					},
					{ text: 'Адрес', value: 'address' },
					{ text: 'Газ', value: 'gas' },
					{ text: 'Холодная вода', value: 'water_cold' },
					{ text: 'Горячая вода', value: 'water_hot' },
					{ text: 'Электричество', value: 'electricity' },
					{ text: 'Отопление', value: 'warm' },
					{ text: 'Итого начислено', value: 'sum' },
					{ text: 'Оплачено', value: 'paid', align: 'center' },
					{ text: '', value: 'data-table-expand' },
					{ text: '', value: 'link', align: 'center', sortable: false },
				],
			}
		},
		watch: {
			options: {
				handler () {
					this.getDataFromApi()
						.then(data => {
							this.setData(data)
						})
				},
				deep: true,
			},
			search() {
				this.getDataFromApi()
					.then(data => {
						this.setData(data)
					})
			},
		},
		mounted () {
			this.getDataFromApi()
				.then(data => {
					this.setData(data)
				})
		},
		methods: {
			getDataFromApi () {
				this.loading = true
				return new Promise((resolve) => {
					const { sortBy, sortDesc, page, itemsPerPage } = this.options

					const search = this.search.trim().toLowerCase();

					let items = this.getData()
					const total = items.length

					if (search) {
						items = items.filter(item => {
							return Object.values(item)
								.join(",")
								.toLowerCase()
								.includes(search);
						});
					}

					if (sortBy.length === 1 && sortDesc.length === 1) {
						items = items.sort((a, b) => {
							const sortA = a[sortBy[0]]
							const sortB = b[sortBy[0]]

							if (sortDesc[0]) {
								if (sortA < sortB) return 1
								if (sortA > sortB) return -1
								return 0
							} else {
								if (sortA < sortB) return -1
								if (sortA > sortB) return 1
								return 0
							}
						})
					}

					if (itemsPerPage > 0) {
						items = items.slice((page - 1) * itemsPerPage, page * itemsPerPage)
					}

					setTimeout(() => {
						this.loading = false
						resolve({
							items,
							total,
						})
					}, 500)
				})
			},
			getData () {
				return [
					{
						id: 1,
						fio: 'Алексеев Алексей Алексеевич',
						address: 'Романа Брянского 1, 1',
						gas: 50,
						water_cold: 100,
						water_hot: 200,
						electricity: 500,
						warm: 1500,
						sum: 2350,
						paid: false,
						phone: '+79201548424'
					},
					{
						id: 2,
						fio: 'Борисов Борис Борисович',
						address: 'Романа Брянского 1, 2',
						gas: 100,
						water_cold: 200,
						water_hot: 300,
						electricity: 400,
						warm: 1800,
						sum: 2800,
						paid: false,
						phone: '+79156548123'
					},
				]
			},
			setData(data) {
				this.landlords = data.items
				this.totalLandlords = data.total
			}
		},
	}
</script>

<style lang="stylus">
	.block-table-landlords
		&__footer-btns
			position absolute
</style>